/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.jsf;

import java.net.URLStreamHandler;
import java.net.URLStreamHandlerFactory;
import sun.net.www.protocol.mem.Handler;

/**
 * <p>The factory for <em>mem://</em> URLs. In JavaSE the factory is added
 * using URL.setURLStreamHandlerFactory method but in tomcat it is 
 * needed the TomcatURLStreamHandlerFactory.addUserFactory method.</p>
 * 
 * @author ricky
 */
public class MemoryStreamHandlerFactory implements URLStreamHandlerFactory {

    /**
     * If the protocol is <em>mem://</em> a new Handler is returned, else
     * null is returned.
     * 
     * @param protocol The protocol of the URL (only "mem" will be managed).
     * @return  The sun.net.www.protocol.mem.Handler handler or null
     */
    @Override
    public URLStreamHandler createURLStreamHandler(String protocol) {
        if ("mem".equalsIgnoreCase(protocol)) {
            return new Handler();
        } else {
            return null;
        }
    }

}
